Unit GraphLot;

INTERFACE

USES GRAPH;

TYPE
  A_Not_Likely_ToBeUsedType = STRING[63];

CONST
  PlotFileName : A_Not_Likely_ToBeUsedType = 'PLOTFILE.HPG';

VAR
  PlotOn,TextOn : BOOLEAN;

PROCEDURE PlotEnd;

PROCEDURE PlotIni;

PROCEDURE BAR(X1,Y1,X2,Y2 : INTEGER);

PROCEDURE BAR3D(X1,Y1,X2,Y2 : INTEGER; DEPTH : WORD; TOP : BOOLEAN);

PROCEDURE CIRCLE(X,Y : INTEGER; RADIUS : WORD);

PROCEDURE FILLPOLY(NUMPOINTS : WORD; VAR POLYPOINTS);

PROCEDURE INITGRAPH(VAR GRAPHDRIVER : INTEGER; VAR GRAPHMODE : INTEGER; DRIVERPATH : STRING);

PROCEDURE SETGRAPHMODE(MODE : INTEGER);

PROCEDURE LINE(X1,Y1,X2,Y2 : INTEGER); { Erstatter GRAPH.LINE }

PROCEDURE LINETO(X,Y : INTEGER);

PROCEDURE OUTTEXT(S1 : STRING);

PROCEDURE OUTTEXTXY(X,Y : INTEGER; S1 : STRING);

PROCEDURE PIESLICE(X,Y : INTEGER; STANGLE,ENDANGLE,RADIUS : WORD);

PROCEDURE DRAWPOLY(NUMPOINTS : WORD; VAR POLYPOINTS);

PROCEDURE RECTANGLE(X1,Y1,X2,Y2 : INTEGER);

PROCEDURE SETBKCOLOR(COLOR : WORD);

PROCEDURE SETCOLOR(COLOR : WORD);

PROCEDURE SETVIEWPORT(X1,Y1,X2,Y2 : WORD; CLIP : BOOLEAN);

IMPLEMENTATION

TYPE
  KS = STRING[15];
  MS = STRING[63];

CONST
  PMX = 11632;
  PMY =  7522;

VAR
  PlotLen : LONGINT;
  GetMaxX,GetMaxY : WORD;
  TheViewPort : VIEWPORTTYPE;
  GraphIsOn,PlotNyt,BolAlignment : BOOLEAN;
  PlotRam : ARRAY[0..2047] OF CHAR;
  Cosines : ARRAY[1..11] OF REAL;
  PlotMaxX : LONGINT;
  PlotMaxY : LONGINT;
  Bo1,Bo2 : BOOLEAN;

PROCEDURE PlotSav;
VAR
  Fil : FILE OF CHAR;
  I,J : INTEGER;
BEGIN
  ASSIGN(Fil,PlotFileName);
  {$I-} RESET(Fil); {$I+}
  IF IORESULT = 0 THEN SEEK(Fil,FILESIZE(Fil)) ELSE REWRITE(Fil);
  FOR I := 0 TO (PlotLen MOD 2048) DO WRITE(Fil,PlotRam[I]);
  CLOSE(Fil);
END;

PROCEDURE PutPlot(SX386 : STRING);
VAR
  I,J : INTEGER;
  L : LINESETTINGSTYPE;
BEGIN
  J := POS('LT;',SX386) + 2;
  IF J > 2 THEN BEGIN
    GETLINESETTINGS(L);
    CASE L.LINESTYLE OF
     1 : INSERT('2,4',SX386,J);
     2 : INSERT('4,1',SX386,J);
     3 : INSERT('3,2',SX386,J);
     4 : INSERT('6,2',SX386,J);
    END;
  END;
  FOR I := 1 TO LENGTH(SX386) DO BEGIN
    IF (PlotLen MOD 2048) = 2047 THEN PlotSav; { Flush filbufferen }
    INC(PlotLen);
    PlotRam[PlotLen MOD 2048] := SX386[I];
  END;
END;

PROCEDURE PlotIni;
VAR
  S1 : KS;
  Fil : FILE;
BEGIN
  ASSIGN(Fil,PlotFileName);
  {$I-} ERASE(Fil); {$I+}
  Bo1 := FALSE;
  PlotLen := IORESULT;
  PlotLen := -1;
  PutPlot(CHR($1B)+'.@;3:'+CHR($1B)+'.I:IN;DF;PU0,0;SP0;SC');
  PlotMaxX := PMX;
  STR(PlotMaxX,S1);
  PutPlot('0,'+S1);
  PlotMaxY := PMY;
  STR(PlotMaxY,S1);
  PutPlot(',0,'+S1+';');
  PlotNyt := TRUE;
  PlotMaxX := (PlotMaxX*1225) DIV 1276; { For at cirkler blir runde }
END;

PROCEDURE PlotEnd;
BEGIN
  PutPlot('SP0;PU0,0;');
  PlotSav;
  Bo1 := FALSE;
END;

PROCEDURE PlotColor(PC : WORD);
VAR
  S1 : KS;
BEGIN
  IF PC = 0 THEN PC := 15 ELSE IF PC = 15 THEN PC := 0;
  STR(SUCC(PC),S1);
  PutPlot('SP'+S1+';');
  Bo1 := FALSE;
END;

PROCEDURE PlotPkt(X,Y : INTEGER);
VAR
  S1 : KS;
  I : INTEGER;
BEGIN
  I := (PlotMaxX*(X+TheViewPort.X1)) DIV GETMAXX;
  STR(I,S1);
  S1 := S1 + ',';
  IF Bo1 THEN PlotRam[PlotLen MOD 2048] := ',';
  PutPlot(S1);
  I := (PlotMaxY*(GETMAXY-Y-TheViewPort.Y1)) DIV GETMAXY;
  STR(I,S1);
  PutPlot(S1);
  IF PlotNyt THEN BEGIN
    PlotNyt := FALSE;
    PlotColor(GETCOLOR);
    PutPlot('LT;');
  END;
END;

PROCEDURE INITGRAPH(VAR GRAPHDRIVER : INTEGER; VAR GRAPHMODE : INTEGER; DRIVERPATH : STRING);
BEGIN
  GRAPH.INITGRAPH(GRAPHDRIVER,GRAPHMODE,DRIVERPATH);
  IF GRAPHDRIVER < 0 THEN GraphIsOn := FALSE ELSE BEGIN
    GETVIEWSETTINGS(TheViewPort);
    GetMaxX := GRAPH.GETMAXX;
    GetMaxY := GRAPH.GETMAXY;
    GraphIsOn := TRUE;
    PlotIni;
  END;
END;

PROCEDURE SETGRAPHMODE(MODE : INTEGER);
BEGIN
  GRAPH.SETGRAPHMODE(MODE);
  IF GRAPHRESULT = 0 THEN BEGIN
    GETVIEWSETTINGS(TheViewPort);
    GetMaxX := GRAPH.GETMAXX;
    GetMaxY := GRAPH.GETMAXY;
    GraphIsOn := TRUE;
    PlotIni;
  END;
END;

PROCEDURE SETVIEWPORT(X1,Y1,X2,Y2 : WORD; CLIP : BOOLEAN);
BEGIN
  GRAPH.SETVIEWPORT(X1,Y1,X2,Y2,CLIP);
  GETVIEWSETTINGS(TheViewPort);
END;

PROCEDURE SETCOLOR(COLOR : WORD);
BEGIN
  IF PlotOn OR TextOn THEN PlotColor(COLOR);
  GRAPH.SETCOLOR(COLOR);
END;

PROCEDURE SETBKCOLOR(COLOR : WORD);
BEGIN
  SETPALETTE(0,COLOR);
END;

PROCEDURE LINE(X1,Y1,X2,Y2 : INTEGER);
BEGIN
  Bo1 := FALSE;
  IF PlotOn THEN BEGIN
    PutPlot('LT;PU');
    PlotPkt(X1,Y1);
    PutPlot(';PD');
    PlotPkt(X2,Y2);
    PutPlot(';');
  END;
  GRAPH.LINE(X1,Y1,X2,Y2);
END;

PROCEDURE LINETO(X,Y : INTEGER);
BEGIN
  IF PlotOn THEN BEGIN
    IF Bo1 THEN BEGIN
      PlotPkt(X,Y);
      PutPlot(';');
      GRAPH.LINETO(X,Y);
    END ELSE BEGIN
      LINE(GETX,GETY,X,Y);
      MOVETO(X,Y);
      Bo1 := TRUE;
    END;
  END ELSE BEGIN
    GRAPH.LINETO(X,Y);
    Bo1 := FALSE;
  END;
END;

PROCEDURE PlotTextXY(X,Y : INTEGER; VAR S1 : STRING);
VAR
  Info : TEXTSETTINGSTYPE;
  XL,YL : INTEGER;
BEGIN
  FOR XL := 1 TO LENGTH(S1)
   DO IF (S1[XL] > #126) OR (S1[XL] < #32) THEN S1[XL] := '?';
  GETTEXTSETTINGS(Info);
  IF Info.DIRECTION = HORIZDIR THEN BEGIN
    PutPlot('DI;PU');
    XL := TEXTWIDTH(S1);
    YL := TEXTHEIGHT(S1);
  END ELSE BEGIN { S er det vertikalt }
    PutPlot('DI0,100;PU');
    YL := TEXTWIDTH(S1);
    XL := -TEXTHEIGHT(S1);
  END;
  XL := XL*Info.HORIZ DIV 2;
  YL := YL*Info.VERT DIV 2;
  PlotPkt(X-XL,Y+YL);
  { PutPlot(';SI00000.2019,00000.2245;LB'+S1+#3);
    Simplex monospaced, 12 punkt men lav (ca 5 pixels) }
  PutPlot(';SI00000.2019,00000.3215;LB'+S1+#3);
  { Simplex monospaced font, 12 punkt }
END;

PROCEDURE OUTTEXTXY(X,Y : INTEGER; S1 : STRING);
BEGIN
  Bo1 := FALSE;
  GRAPH.OUTTEXTXY(X,Y,S1);
  IF TextOn THEN PlotTextXY(X,Y,S1);
END;

PROCEDURE OUTTEXT(S1 : STRING);
VAR
  X,Y : INTEGER;
BEGIN
  X := GETX;
  Y := GETY;
  GRAPH.OUTTEXT(S1);
  IF TextOn THEN PlotTextXY(X,Y,S1);
  Bo1 := FALSE;
END;

CONST
  FillTypes : ARRAY [1..12] OF KS =
   ('FT1;','FT3,80,135;','FT5,60,45;','FT5,80,90','FT5,120,90;','FT5,90,45;',
    'FT4,30,45;','FT4,45,60;','FT6,90,90;','FT7,60,60;','FT7,30,30;','FT6,45,45');

PROCEDURE PlotFill(FillType : WORD);
VAR
  Fyld : FILLSETTINGSTYPE;
BEGIN
  GETFILLSETTINGS(Fyld);
  IF (Fyld.PATTERN = EMPTYFILL) OR (FillType = 0) THEN PutPlot('EP;')
  ELSE BEGIN
    PutPlot(FillTypes[Fyld.PATTERN]);
    PlotColor(Fyld.COLOR);
    PutPlot('FP;LT;EP;');
    PlotColor(GETCOLOR);
  END;
END;

PROCEDURE BAR(X1,Y1,X2,Y2 : INTEGER);
BEGIN
  IF PlotOn THEN BEGIN
    PutPlot('PU');
    PlotPkt(X1,Y1);
    PutPlot(';PM0;PD');
    PlotPkt(X2,Y1);
    PutPlot(',');
    PlotPkt(X2,Y2);
    PutPlot(',');
    PlotPkt(X1,Y2);
    PutPlot(';PM2;LT;');
    PlotFill(1);
  END;
  GRAPH.BAR(X1,Y1,X2,Y2);
  Bo1 := FALSE;
END;

PROCEDURE RECTANGLE(X1,Y1,X2,Y2 : INTEGER);
BEGIN
  IF PlotOn THEN BEGIN
    PutPlot('PU');
    PlotPkt(X1,Y1);
    PutPlot(';PM0;PD');
    PlotPkt(X2,Y1);
    PutPlot(',');
    PlotPkt(X2,Y2);
    PutPlot(',');
    PlotPkt(X1,Y2);
    PutPlot(';PM2;LT;EP;');
  END;
  GRAPH.RECTANGLE(X1,Y1,X2,Y2);
  Bo1 := FALSE;
END;

PROCEDURE LowFirst(VAR FIRST,SECOND : INTEGER);
BEGIN
  INLINE
                     {         PROC    NEAR }
                     { FIRST   EQU     3333H }
                     { SECOND  EQU     4444H }
   ($1E/             {         PUSH    DS }
    $C5/$B6/FIRST/   {         LDS     SI,[BP+FIRST] }
    $C4/$BE/SECOND/  {         LES     DI,[BP+SECOND] }
    $8B/$04/         {         MOV     AX,[SI] }
    $26/             {         ES: }
    $3B/$05/         {         CMP     AX,[DI] }
    $7E/$05/         {         JLE     SLUT }
    $26/             {         ES: }
    $87/$05/         {         XCHG    AX,[DI] }
    $89/$04/         {         MOV     [SI],AX }
    $1F);            { SLUT    POP     DS }
                     {         ENDP }
END;

PROCEDURE BAR3D(X1,Y1,X2,Y2 : INTEGER; DEPTH : WORD; TOP : BOOLEAN);
VAR
  Yd : INTEGER;
BEGIN
  LowFirst(X1,X2);
  BAR(X1,Y1,X2,Y2); { BAR og LINE kun plottet hvis PlotOn }
  GRAPH.RECTANGLE(X1,Y1,X2,Y2);
  IF DEPTH > 0 THEN BEGIN
    Yd := (3*DEPTH) DIV 4;
    LINE(X2,Y2,X2+DEPTH,Y2-Yd);
    LINE(X2,Y1,X2+DEPTH,Y1-Yd);
    LINE(X2+DEPTH,Y1-Yd,X2+DEPTH,Y2-Yd);
    IF TOP THEN BEGIN
      LowFirst(Y2,Y1);
      LINE(X1,Y2,X1+DEPTH,Y2-Yd);
      LINE(X1+DEPTH,Y2-Yd,X2+DEPTH,Y2-Yd);
    END;
  END;
  Bo1 := FALSE;
END;

PROCEDURE PlotPt2(X,Y : INTEGER);
VAR
  S1 : KS;
  I : INTEGER;
BEGIN
  STR(X,S1);
  PutPlot(S1+',');
  STR(Y,S1);
  PutPlot(S1);
END;

PROCEDURE DRAWPOLY(NUMPOINTS : WORD; VAR POLYPOINTS);
TYPE
  PolyPoint = ARRAY[1..256] OF RECORD X : INTEGER; Y : INTEGER; END;
VAR
  W : WORD;
  P : ^PolyPoint;
BEGIN
  GRAPH.DRAWPOLY(NUMPOINTS,POLYPOINTS);
  Bo1 := FALSE;
  IF PlotOn AND (NUMPOINTS > 1) THEN BEGIN
    P := @POLYPOINTS;
    IF  (P^[1].X = P^[NUMPOINTS].X) AND (P^[1].Y = P^[NUMPOINTS].Y)
    THEN BEGIN
      PutPlot('PU');
      PlotPkt(P^[1].X,P^[1].Y);
      PutPlot(';PM0;PD');
      PlotPkt(P^[2].X,P^[2].Y);
      FOR W := 3 TO PRED(NUMPOINTS) DO BEGIN
        PutPlot(',');
        PlotPkt(P^[W].X,P^[W].Y);
      END;
      PutPlot(';PM2;LT;EP;');
    END ELSE BEGIN
      PutPlot('PU');
      PlotPkt(P^[1].X,P^[1].Y);
      PutPlot(';PD');
      PlotPkt(P^[2].X,P^[2].Y);
      FOR W := 3 TO NUMPOINTS DO BEGIN
        PutPlot(',');
        PlotPkt(P^[W].X,P^[W].Y);
      END;
      PutPlot(';');
    END;
  END;
END;

PROCEDURE FILLPOLY(NUMPOINTS : WORD; VAR POLYPOINTS);
TYPE
  PolyPoint = ARRAY[1..256] OF RECORD X : INTEGER; Y : INTEGER; END;
VAR
  W : WORD;
  P : ^PolyPoint;
BEGIN
  GRAPH.FILLPOLY(NUMPOINTS,POLYPOINTS);
  Bo1 := FALSE;
  P := @POLYPOINTS;
  IF (P^[1].X = P^[NUMPOINTS].X) AND (P^[1].Y = P^[NUMPOINTS].Y)
   THEN DEC(NUMPOINTS);
  IF PlotOn AND (NUMPOINTS > 1) THEN BEGIN
    PutPlot('PU');
    PlotPkt(P^[1].X,P^[1].Y);
    PutPlot(';PM0;PD');
    PlotPkt(P^[2].X,P^[2].Y);
    FOR W := 3 TO NUMPOINTS DO BEGIN
      PutPlot(',');
      PlotPkt(P^[W].X,P^[W].Y);
    END;
    PutPlot(';PM2;LT;');
    PlotFill(1);
  END;
END;

FUNCTION CircleXs(Nr : INTEGER) : REAL;
VAR
  Fortegn : INTEGER;
BEGIN
  WHILE Nr < 0 DO Nr := Nr + 240;
  Nr := Nr MOD 48;
  IF Nr > 24 THEN Nr := 48 - Nr;
  IF Nr = 12 THEN CircleXs := 0 ELSE BEGIN
    IF Nr > 12 THEN BEGIN
      Fortegn := -1;
      Nr := 24 - Nr;
    END ELSE Fortegn := 1;
    IF Nr > 0 THEN
      CircleXs := Fortegn*Cosines[Nr]
    ELSE CircleXs := Fortegn;
  END;
END;

FUNCTION CircleYs(Nr : INTEGER) : REAL;
BEGIN
  CircleYs := CircleXs(Nr + 36);
END;

PROCEDURE CIRCLE(X,Y : INTEGER; RADIUS : WORD);
VAR
  I,J,K,X0,Y0,RX,RY : INTEGER;
BEGIN
  Bo1 := FALSE;
  IF PlotOn THEN BEGIN
    RX := (RADIUS*PlotMaxX) DIV GETMAXX;
    RY := (RADIUS*PlotMaxY) DIV GETMAXY;
    X0 := ((X+TheViewPort.X1)*PlotMaxX) DIV GETMAXX;
    Y0 := ((GETMAXY-Y-TheViewPort.Y1)*PlotMaxY) DIV GETMAXY;
    PutPlot('PU');
    PlotPt2(X0+RX,Y0);  { Start i bunden af 1. kvadrant }
    PutPlot(';PM0;PD');
    IF RADIUS < 3 THEN J := 6 ELSE
     IF RADIUS < 6 THEN J := 4 ELSE
      IF RADIUS < 10 THEN J := 3 ELSE
       IF RADIUS < 15 THEN J := 2 ELSE J := 1;
    K := PRED(48 DIV J);
    FOR I := 1 TO K DO BEGIN
      PlotPt2(X0+ROUND(RX*CircleXs(I*J)),Y0+ROUND(RY*CircleYs(I*J)));
      IF I < K THEN PutPlot(',');
    END;
    PutPlot(';PM2;LT;EP;');
  END;
  GRAPH.CIRCLE(X,Y,RADIUS);
END;

PROCEDURE PIESLICE(X,Y : INTEGER; STANGLE,ENDANGLE,RADIUS : WORD);
TYPE
  PolyPoint = ARRAY[0..51] OF RECORD X : INTEGER; Y : INTEGER; END;
VAR
  I,J,K,L,X0,Y0,RX,RY : INTEGER;
  Fr : REAL;
  ScrPoint : PolyPoint;
BEGIN
  Bo1 := FALSE;
  STANGLE := STANGLE MOD 360;
  ENDANGLE := ENDANGLE MOD 360;
  RX := 0;
  IF (ENDANGLE <> 359) OR (STANGLE <> 0) THEN BEGIN
    ScrPoint[RX].X := X;
    ScrPoint[RX].Y := Y;
    INC(RX);
  END;
  IF ENDANGLE <= STANGLE THEN ENDANGLE := ENDANGLE + 360;
  Fr := FRAC(STANGLE/7.5);
  I := TRUNC(STANGLE/7.5);
  IF Fr > 0 THEN BEGIN
    K := ROUND((1-Fr)*RADIUS*CircleXs(I)+Fr*RADIUS*CircleXs(SUCC(I)));
    L := ROUND((1-Fr)*RADIUS*CircleYs(I)+Fr*RADIUS*CircleYs(SUCC(I)));
    ScrPoint[RX].X := X+K;
    ScrPoint[RX].Y := Y-L;
    INC(I);
    INC(RX);
  END;
  FOR J := I TO TRUNC(ENDANGLE/7.5) DO BEGIN
    K := ROUND((1-Fr)*RADIUS*CircleXs(J)+Fr*RADIUS*CircleXs(SUCC(J)));
    L := ROUND((1-Fr)*RADIUS*CircleYs(J)+Fr*RADIUS*CircleYs(SUCC(J)));
    ScrPoint[RX].X := X+K;
    ScrPoint[RX].Y := Y-L;
    INC(RX);
  END;
  Fr := FRAC(ENDANGLE/7.5);
  IF Fr > 0 THEN BEGIN
    K := ROUND((1-Fr)*RADIUS*CircleXs(J)+Fr*RADIUS*CircleXs(SUCC(J)));
    L := ROUND((1-Fr)*RADIUS*CircleYs(J)+Fr*RADIUS*CircleYs(SUCC(J)));
    ScrPoint[RX].X := X+K;
    ScrPoint[RX].Y := Y-L;
    INC(RX);
  END;
  GRAPH.FILLPOLY(RX,ScrPoint);
  IF PlotOn THEN BEGIN
    RX := (RADIUS*PlotMaxX) DIV GETMAXX;
    RY := (RADIUS*PlotMaxY) DIV GETMAXY;
    X0 := ((X+TheViewPort.X1)*PlotMaxX) DIV GETMAXX;
    Y0 := ((GETMAXY-Y-TheViewPort.Y1)*PlotMaxY) DIV GETMAXY;
    PutPlot('PU');
    PlotPt2(X0,Y0);  { Start i centrum }
    PutPlot(';PM0;PD');
    STANGLE := STANGLE MOD 360;
    ENDANGLE := ENDANGLE MOD 360;
    IF ENDANGLE < STANGLE THEN ENDANGLE := ENDANGLE + 360;
    Fr := FRAC(STANGLE/7.5);
    I := TRUNC(STANGLE/7.5);
    IF Fr > 0 THEN BEGIN
      K := ROUND((1-Fr)*RX*CircleXs(I)+Fr*RX*CircleXs(SUCC(I)));
      L := ROUND((1-Fr)*RY*CircleYs(I)+Fr*RY*CircleYs(SUCC(I)));
      PlotPt2(X0+K,Y0+L);
      INC(I);
    END;
    J := TRUNC(ENDANGLE/7.5);
    FOR K := I TO J DO BEGIN
      PutPlot(',');
      PlotPt2(X0+ROUND(RX*CircleXs(K)),Y0+ROUND(RY*CircleYs(K)));
    END;
    Fr := FRAC(ENDANGLE/7.5);
    IF Fr > 0 THEN BEGIN
      PutPlot(',');
      K := ROUND((1-Fr)*RX*CircleXs(J)+Fr*RX*CircleXs(SUCC(J)));
      L := ROUND((1-Fr)*RY*CircleYs(J)+Fr*RY*CircleYs(SUCC(J)));
      PlotPt2(X0+K,Y0+L);
      INC(I);
    END;
    PutPlot(';PM2;LT;EP;');
  END;
END;

PROCEDURE MakeCirclePoints;
VAR
  I : WORD;
BEGIN
  FOR I := 1 TO 11 DO Cosines[I] := COS(I*PI/24);
END;

BEGIN
  MakeCirclePoints;
  PlotOn := TRUE;
  TextOn := TRUE;
END.