PROGRAM XY_plot;

 { Et program til grafisk fremstilling af matematiske funktioner }
 { De fremkomne kurver udskrives i plot-fil i HPGL formatet }
 { som kan importeres af de fleste tegneprogrammer og en del }
 { nyerere tekstbehandlingsprogrammer }

 { Programmet er skrevet i TurboPascal 4.0 af Lars Quist, }
 { sidste revision 24. juli 1995 }

USES CRT,DOS,GRAPH,GRAPHLOT;

CONST
  Udefineret = 0;
  Funktion : ARRAY[0..63] OF STRING[6] =
     ('(','AND','NAND','OR','NOR','XOR','NXOR','',        { 192 }
     '<','=','>','<=','>=','<>','=<','><',                { 200 }
     '-','+','*','/','DIV','MOD','MUL','^',               { 208 }
     'SEK','MIN','TIME','DAG','MN','R','','REP',        { 216 }
     'LN','EXP','LOG','E10','SQR','SQRT','','',           { 224 }
     'SIN','ARCSIN','COS','ARCCOS','TAN','ARCTAN','','',  { 232 }
     '','FRAC','ABS','','ROUND','INT','NOT','*NEG*',      { 240 }
     'PI','FALSK','SAND','','','','','');                 { 248 }

TYPE
  KS = STRING[7];
  FeltStrg = STRING[11];
  FeltIndh = ARRAY [0..15] OF REAL;
  PostPtr = ^FeltIndh;
  LimitType = ARRAY [1..2] OF REAL;

VAR
  DataAnt : INTEGER;
  Xlimits : ARRAY [1..9] OF LimitType;
  Algoritme : ARRAY [1..9] OF STRING;
  Algotext : ARRAY [1..9] OF STRING;
  AlgoType : ARRAY [1..9] OF CHAR;
  IndxIalg : ARRAY [1..9] OF BOOLEAN;
  DataPntr : ARRAY [0..1025] OF PostPtr;
  FeltType : ARRAY [0..15] OF CHAR;
  FeltAntl : INTEGER;
  FeltNavn : ARRAY [0..9] OF KS;
  PostNr,AlgoAntl : INTEGER;
  Index,Findex,IndxAntl : INTEGER;
  FejlNr : INTEGER;
  FejlMedd : STRING;
  Fejl,FejlX,Bool1,Bool2 : BOOLEAN;
  Driver,Mode : INTEGER;
  Xven,Xhoj,Yopp,Yned : INTEGER;

PROCEDURE ZeroVars;
BEGIN
  DataAnt := 0;
  FOR FeltAntl := 1 TO 9 DO BEGIN
    Algoritme[FeltAntl] := '';
    AlgoText[FeltAntl] := '';
    AlgoType[FeltAntl] := '?';
    IndxIalg[FeltAntl] := FALSE;
    FeltNavn[PRED(FeltAntl)] := CHR(FeltAntl + ORD('V'));
    FeltType[FeltAntl] := 'R';
    Xlimits[FeltAntl][1] := 0;
    Xlimits[FeltAntl][2] := 0;
  END;
  FOR Index := 3 TO 9 DO FeltNavn[Index] := 'Y' + CHR(47+Index);
  Xlimits[1][2] := 10;
  Index := 0;
  Findex := 0;
  IndxAntl := 0;
  FeltAntl := 1;
END;

{$I D:\VARME\READLN2.PAS}

FUNCTION LavPaentTal(VAR Tal : REAL) : INTEGER;
VAR                { LavPaentTal bliver nrmeste }
  Mant : REAL;     { potens MOD 3 ( EE ) og Tal  }
  Expo,Temp : INTEGER;  { omdannet modsvarende }
  Minus : BOOLEAN; { dvs: Tal * 10^Paent = gl Tal }
BEGIN
  LavPaentTal := 0;
  IF Tal = 0 THEN EXIT;
  Minus := Tal < 0;
  IF Minus THEN Tal := -Tal;
  Mant := LN(Tal)/LN(10);
  Expo := TRUNC(Mant);
  Mant := FRAC(Mant);
  IF Mant < 0 THEN
    BEGIN
      Mant := Mant + 1;
      Expo := Expo - 1;
    END;
  Temp := Expo MOD 3;
  IF Temp = -2 THEN Temp := Temp + 3;
  Mant := Mant + Temp;
  LavPaentTal := Expo - Temp;
  Tal := EXP(Mant*LN(10));
  IF Minus THEN Tal := -Tal;
END;

PROCEDURE PaenGraense(VAR Min,Max : REAL; Bid : BYTE);
VAR                   { Min bliver pn minimum }
  Diff,Expo : REAL;   { Max bliver pn maximum }
  Potens : INTEGER;   { Bid er nsket antal bidder }
BEGIN
  Diff := LN((Max - Min)/Bid)/LN(10);
  Potens := TRUNC(Diff);
  Diff := FRAC(Diff);
  IF Diff < 0 THEN BEGIN
    Diff := Diff + 1;
    Potens := Potens - 1;
  END;
  Diff := EXP(Diff*LN(10));
  IF Diff > 5 THEN Diff := 10
  ELSE IF Diff > 2 THEN Diff := 5
  ELSE IF Diff > 1 THEN Diff := 2
  ELSE Diff := 1;
  IF Diff = 10 THEN BEGIN
    Diff := 1;
    INC(Potens);
  END;
  Expo := EXP(Potens*LN(10));
  Min := Min/Expo;
  Max := Max/Expo;
  Potens := TRUNC(Min/Diff);
  IF Min < Diff*Potens THEN DEC(Potens);
  IF Max > Diff*(Potens+Bid) THEN Diff := 2*Diff;
  IF Diff = 4 THEN Diff := 5;
  Potens := TRUNC(Min/Diff);
  IF Min < Diff*Potens THEN DEC(Potens);
  Min := Expo*Diff*Potens;
  Max := Min + Diff*Bid*Expo;
END;

PROCEDURE StoreBogst(VAR Tekst : FeltStrg);
VAR
  A : BYTE;
BEGIN
  FOR A := 1 TO LENGTH(Tekst) DO
    Tekst[A] := UPCASE(Tekst[A]);
END;

PROCEDURE SpcsVaek(VAR Tekst : FeltStrg);
BEGIN
  WHILE 1 = POS(#32,Tekst) DO DELETE(Tekst,1,1);
  WHILE #32 = Tekst[LENGTH(Tekst)] DO DELETE(Tekst,LENGTH(Tekst),1);
END;

FUNCTION SkifVens(Tekst : FeltStrg) : FeltStrg;
BEGIN
  SpcsVaek(Tekst);
  WHILE LENGTH(Tekst) < 10 DO Tekst := Tekst + #32;
  SkifVens := Tekst;
END;

FUNCTION SkifHoej(Tekst : FeltStrg) : FeltStrg;
BEGIN
  SpcsVaek(Tekst);
  WHILE LENGTH(Tekst) < 10 DO Tekst := #32 + Tekst;
  SkifHoej := Tekst;
END;

FUNCTION Centrer(Tekst : FeltStrg) : FeltStrg;
BEGIN
  SpcsVaek(Tekst);
  WHILE LENGTH(Tekst) < 9 DO Tekst := #32 + Tekst + #32;
  IF LENGTH(Tekst) < 10 THEN Tekst := Tekst + #32;
  Centrer := Tekst;
END;

FUNCTION TalTilStreng(Tal : REAL;Expo : INTEGER;Dec : BYTE) : FeltStrg;
VAR
  Temp,Mant : FeltStrg;
BEGIN
  STR(Tal:5:Dec,Mant);
  IF Tal = 0 THEN Mant := '0';
  STR(Expo,Temp);
  IF Temp[1] <> '-' THEN Temp := '+' + Temp;
  IF Expo <> 0 THEN Mant := Mant+'E'+Temp;
  SpcsVaek(Mant);
  TalTilStreng := Mant;
END;

FUNCTION FireCifr(Tal : REAL) : FeltStrg;
VAR
  TS  : FeltStrg;
  Dec : BYTE;             { Omdanner Tal til streng med }
  Hel : INTEGER;          { fire betydende cifre og }
BEGIN                     { eventuel exponent }
  IF (ABS(Tal)<10000) AND (Tal<>0) AND (ABS((Tal-ROUND(Tal))/Tal)<0.0005)
  THEN BEGIN
    Hel := ROUND(Tal);
    STR(Hel,TS);
  END ELSE BEGIN
    Hel := LavPaentTal(Tal);
    IF ABS(Tal) > 9.999 THEN Dec := 2 ELSE Dec := 3;
    IF ABS(Tal) > 99.99 THEN Dec := 1;
    TS := TalTilStreng(Tal,Hel,Dec);
  END;
  FireCifr := TS;
END;

FUNCTION StrengAfTal(T : REAL; Ftyp : CHAR) : FeltStrg;
VAR
  Temp : FeltStrg;
  B,P : BYTE;
BEGIN
  CASE Ftyp OF
   'C' : Temp := CHR(ROUND(T));
   'I' : STR(ROUND(T),Temp);
   'L' : IF T = 1 THEN Temp := 'SAND'
         ELSE IF T = 0 THEN Temp := 'FALSK'
         ELSE Temp := '?';
   'R' : Temp := FireCifr(T);
   'S' : BEGIN
           P := 0;
           WHILE T > 0 DO BEGIN
             B := TRUNC(T);
             T := 128*FRAC(T);
             INC(P);
             CASE B OF
               091 : B := 157; {  }
               092 : B := 146; {  }
               093 : B := 143; {  }
               123 : B := 155; {  }
               124 : B := 145; {  }
               125 : B := 134; {  }
             END;
             Temp[P] := CHR(B);
           END;
           Temp[0] := CHR(P);
         END;
  END;
  StrengAfTal := Temp;
END;

FUNCTION TalAfStreng(Streng : FeltStrg) : REAL;
VAR
  Tal : REAL;
  I,B : BYTE;
BEGIN
  Tal := 0;
  IF Streng[0] > #5 THEN Streng[0] := #5;
  FOR I := LENGTH(Streng) DOWNTO 1 DO
    BEGIN
      B := ORD(Streng[I]);
      CASE B OF
        134 : B := 125; {  }
        143 : B := 093; {  }
        145 : B := 124; {  }
        146 : B := 092; {  }
        155 : B := 123; {  }
        157 : B := 091; {  }
      END;
      Tal := Tal/128 + B;
    END;
  TalAfStreng := Tal;
END;

FUNCTION FeltTilStreng(Felt : BYTE) : FeltStrg;
{ Omstter det reelle tal DataPntr[PostNr]^[Felt]
  til en streng i henhold til typen angivet i
  FeltType[Felt] }
VAR
  Temp : FeltStrg;
  Typ : CHAR;
BEGIN
  Typ := FeltType[Felt];
  Temp := StrengAfTal(DataPntr[PostNr]^[Felt],Typ);
  IF (Typ = 'I') OR (Typ = 'R') THEN FeltTilStreng := SkifHoej(Temp)
  ELSE FeltTilStreng := SkifVens(Temp);
END;

FUNCTION BeregnAlgoritme(Nr : BYTE) : REAL;
VAR
  StNr,AlNr,Slut,Kode,GamI : BYTE;
  I : INTEGER;
  Stak : ARRAY [1..20] OF REAL;
  T,T1 : REAL;
BEGIN
  StNr := 0;
  AlNr := 0;
  Slut := LENGTH(Algoritme[Nr]);
  WHILE AlNr < Slut DO BEGIN
    INC(AlNr);
    Kode := ORD(Algoritme[Nr][AlNr]);
    IF Kode < 134 THEN INC(StNr)
    ELSE IF Kode > 192 THEN BEGIN
      T := Stak[StNr];
      IF (Kode < 216) OR (Kode > 248) THEN BEGIN
        T1 := T;
        DEC(StNr);
        T := Stak[StNr];
      END;
    END;
    CASE Kode OF
      0..63    : Stak[StNr] := DataPntr[PostNr]^[Kode];
                 { Variabel }
      64..126  : Stak[StNr] := DataPntr[PostNr]^[Index + (63 AND Kode)];
                 { Variabel med index }
      127      : Stak[StNr] := DataPntr[0]^[Index + Findex];
                 { Index }
      128      : BEGIN  { Konstant }
                   MOVE(Algoritme[Nr][AlNr+1],Stak[StNr],6);
                   AlNr := AlNr + 6;
                 END;
      129      : Stak[StNr] := PI;
      130      : Stak[StNr] := 0;   { Logisk FALSK }
      131      : Stak[StNr] := 1;   { Logisk SAND }
      132      : Stak[StNr] := -128; { Logisk ? }
      133      : BEGIN  { Start p REP }
                   Stak[StNr] := 0;
                   Index := 0;
                 END;
      193      : Stak[StNr] := TRUNC(T) AND TRUNC(T1);      { binr AND }
      194      : Stak[StNr] := NOT(TRUNC(T) AND TRUNC(T1)); { binr NAND }
      195      : Stak[StNr] := TRUNC(T) OR TRUNC(T1);       { binr OR }
      196      : Stak[StNr] := NOT(TRUNC(T) OR TRUNC(T1));  { binr NOR }
      197      : Stak[StNr] := TRUNC(T) XOR TRUNC(T1);      { binr XOR }
      198      : Stak[StNr] := NOT(TRUNC(T) XOR TRUNC(T1)); { binr NXOR }
      200      : IF T < T1 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { < }
      201      : IF T = T1 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { = }
      202      : IF T > T1 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { > }
      203      : IF T <= T1 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { <= }
      204      : IF T >= T1 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { >= }
      205      : IF T <> T1 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { <> }
      206      : IF (T >= T1) AND (T < (1 + TRUNC(T1)))
                 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { =< }
      207      : IF POS(StrengAfTal(T,'S'),StrengAfTal(T1,'S')) > 0
                 THEN Stak[StNr] := 1 ELSE Stak[StNr] := 0; { >< }
      208      : Stak[StNr] := T - T1;
      209      : Stak[StNr] := T + T1;
      210      : Stak[StNr] := T * T1;
      211      : Stak[StNr] := T / T1;
      212      : Stak[StNr] := TRUNC(T) DIV TRUNC(T1);
      213      : Stak[StNr] := TRUNC(T) MOD TRUNC(T1);
      214      : Stak[StNr] := TRUNC(T) * TRUNC(T1);
      215      : IF FRAC(T1) <> 0   { Potenser }
                 THEN Stak[StNr] := EXP(LN(T)*T1)
                 ELSE BEGIN
                   I := ROUND(T1);
                   Stak[StNr] := 1;
                   T1 := T;
                   WHILE I > 0 DO BEGIN
                     DEC(I);
                     Stak[StNr] := Stak[StNr] * T1;
                   END;
                   WHILE I < 0 DO BEGIN
                     INC(I);
                     Stak[StNr] := Stak[StNr] / T1;
                   END;
                 END;
      216      : BEGIN END; { SEK }
      217      : BEGIN END; { MIN }
      218      : BEGIN END; { TIME }
      219      : BEGIN END; { DAG }
      220      : BEGIN END; { MN }
      221      : BEGIN END; { R }
      223      : BEGIN      { Repeter }
                   INC(AlNr);
                   IF (Index < IndxAntl) AND (Stak[StNr] <> 1) THEN BEGIN
                     INC(Index);      { Repeter }
                     AlNr := ORD(Algoritme[Nr][AlNr]);
                   END;
                 END;
      224      : Stak[StNr] := LN(T); { LN }
      225      : Stak[StNr] := EXP(T); { EXP }
      226      : Stak[StNr] := LN(T)/LN(10); { LOG }
      227      : Stak[StNr] := EXP(T*LN(10)); { ANTILOG }
      228      : Stak[StNr] := SQR(T); { SQR }
      229      : Stak[StNr] := SQRT(T); { SQRT }
      232      : Stak[StNr] := SIN(T); { SIN }
      233      : IF (T = 0) OR (ABS(T) = 1) THEN BEGIN   { ARCSIN }
                   IF ABS(T) = 1 THEN Stak[StNr] := T*PI/2;
                 END ELSE BEGIN
                   Stak[StNr] := ARCTAN(1/SQRT(1/SQR(T)-1));
                   IF T < 0 THEN Stak[StNr] := -Stak[StNr];
                 END;
      234      : Stak[StNr] := COS(T); { SIN }
      235      : IF T = 0 THEN Stak[StNr] := PI/2    { ARCCOS }
                 ELSE BEGIN
                   Stak[StNr] := ARCTAN(SQRT(1/SQR(T)-1));
                   IF T < 0 THEN Stak[StNr] := PI - Stak[StNr];
                 END;
      236      : Stak[StNr] := SIN(T)/COS(T); { TAN }
      237      : Stak[StNr] := ARCTAN(T); { ARCTAN }
      241      : Stak[StNr] := FRAC(T); { FRAC }
      242      : Stak[StNr] := ABS(T); { ABS }
      244      : Stak[StNr] := ROUND(T); { ROUND }
      245      : Stak[StNr] := INT(T); { INT }
      246      : Stak[StNr] := NOT TRUNC(T); { Binr NOT }
      247      : Stak[StNr] := -T; { *NEG* }
      248      : IF (T = 1) OR (T = 0)            { Logisk NOT }
                 THEN Stak[StNr] := 1 XOR TRUNC(T)
                 ELSE Stak[StNr] := -128;
      249      : IF (T = 1) AND (T1 = 1)          { Logisk AND }
                 THEN Stak[StNr] := 1
                 ELSE IF (T = 0) OR (T1 = 0)
                 THEN Stak[StNr] := 0 ELSE Stak[StNr] := -128;
      250      : IF (T = 1) AND (T1 = 1)          { Logisk NAND }
                 THEN Stak[StNr] := 0
                 ELSE IF (T = 0) OR (T1 = 0)
                 THEN Stak[StNr] := 1 ELSE Stak[StNr] := -128;
      251      : IF (T = 1) OR (T1 = 1)           { Logisk OR }
                 THEN Stak[StNr] := 1
                 ELSE IF (T = 0) AND (T1 = 0)
                 THEN Stak[StNr] := 0 ELSE Stak[StNr] := -128;
      252      : IF (T = 1) OR (T1 = 1)           { Logisk NOR }
                 THEN Stak[StNr] := 0
                 ELSE IF (T = 0) AND (T1 = 0)
                 THEN Stak[StNr] := 1 ELSE Stak[StNr] := -128;
      253      : IF ((T = 1) AND (T1 = 0)) OR ((T = 0) AND (T1 = 1))
                 THEN Stak[StNr] := 1
                 ELSE IF (T = T1) AND ((T = 0) OR (T = 1))
                 THEN Stak[StNr] := 0
                 ELSE Stak[StNr] :=-128;         { Logisk XOR }
      254      : IF ((T = 1) AND (T1 = 0)) OR ((T = 0) AND (T1 = 1))
                 THEN Stak[StNr] := 0
                 ELSE IF (T = T1) AND ((T = 0) OR (T = 1))
                 THEN Stak[StNr] := 1
                 ELSE Stak[StNr] :=-128;          { Logisk NXOR }
    END;
  END;
  BeregnAlgoritme := Stak[StNr];
END;

FUNCTION FeltNr(Felt : FeltStrg) : BYTE;
VAR
  I,T : INTEGER;
  B,P : BYTE;
  S : FeltStrg;
BEGIN
  StoreBogst(Felt);
  S := Felt;
  T := -1;
  P := POS('.',S);
  IF Felt = 'INDEX' THEN B := 127 ELSE BEGIN
    IF P > 0 THEN BEGIN
      DELETE(Felt,P,10);
      DELETE(S,1,P);
      VAL(S,T,I);
      P := 255;
      IF I = 0 THEN FOR B := 0 TO IndxAntl DO
        IF DataPntr[0]^[B+Findex] = T THEN P := B;
    END ELSE S := '';
    B := 255;
    FOR I := FeltAntl DOWNTO 0 DO IF Felt = FeltNavn[I] THEN B := I;
    IF B = 255 THEN FejlMedd := 'Ukendt felt';
    IF B < 64 THEN IF S = '' THEN BEGIN
      IF DataPntr[0]^[B] <> -1 THEN B := B + 64;
    END ELSE BEGIN
      IF (P = 255) OR (DataPntr[0]^[B+P] <> T)
        THEN FejlMedd := 'Illegal index'
        ELSE B := B + P;
    END;
  END;
  FeltNr := B;
END;

PROCEDURE FortolkAlgoritme(Nr : BYTE);
VAR
  Alg : STRING;
  A,B,Anr,Knr,Snr,Tnr : BYTE;
  Kode,Tegn,ForrKode,ForrType,TalTyp,Loop : CHAR;
  I : INTEGER;
  Tal : REAL;
  Streng : FeltStrg;
  KodeSt,TypeSt : ARRAY [1..20] OF CHAR;
  FejlSt : ARRAY [1..20] OF INTEGER;
  StrSt : ARRAY [1..10] OF REAL;
  IndxHeri : BOOLEAN;
FUNCTION StakNed : BOOLEAN;
VAR
  Op,Ty,Ty2 : CHAR;
  ToTal : BOOLEAN;
  GamFejl : INTEGER;
BEGIN
  StakNed := TRUE;
  GamFejl := FejlNr;
  IF Knr = 0 THEN EXIT;
  FejlMedd := 'Type passer ikke';
  FejlNr := FejlSt[Knr];
  INC(Anr);
  Op := KodeSt[Knr];
  DEC(Knr);
  Ty := TypeSt[Tnr];
  ToTal := FALSE;
  IF (Op > #192) AND (Op < #216) THEN BEGIN
    DEC(Tnr);
    IF Tnr = 0 THEN BEGIN
      FejlMedd := 'Tal mangler';
      EXIT;
    END;
    Ty2 := TypeSt[Tnr];
    IF (Ty = 'I') OR (Ty = 'R') THEN
      IF (Ty2 = 'I') OR (Ty2 = 'R') THEN ToTal := TRUE;
  END;
  Algoritme[Nr][Anr] := Op;
  CASE Op OF
    #193..#199 : BEGIN     { AND OR etc }
                   IF NOT ToTal THEN BEGIN
                     IF (Ty <> 'L') OR (Ty2 <> 'L') THEN EXIT;
                     Algoritme[Nr][Anr] := CHR(56+ORD(Op));
                     TypeSt[Tnr] := 'L';
                   END ELSE BEGIN
                     IF (Ty = 'R') OR (Ty2 = 'R') THEN FejlX := TRUE;
                     TypeSt[Tnr] := 'I';
                   END;
                 END;
    #200..#205 : BEGIN      { Relationer }
                   TypeSt[Tnr] := 'L';
                   IF NOT ToTal THEN IF Ty <> Ty2 THEN EXIT;
                 END;
    #206..#207 : BEGIN      { Strengrelationer }
                   TypeSt[Tnr] := 'L';
                   IF (Ty <> 'S') OR (Ty2 <> 'S') THEN EXIT;
                 END;
    #208..#210 : BEGIN      { + - og * }
                   IF NOT ToTal THEN EXIT;
                   IF (Ty = 'I') AND (Ty2 = 'I')
                     THEN TypeSt[Tnr] := 'I' ELSE TypeSt[Tnr] := 'R'
                 END;
    #211       : BEGIN        { / }
                   TypeSt[Tnr] := 'R';
                   IF NOT ToTal THEN EXIT;
                 END;
    #212..#214 : BEGIN    { DIV MOD MUL }
                   IF NOT ToTal THEN EXIT;
                   TypeSt[Tnr] := 'I';
                   IF (Ty = 'R') OR (Ty2 = 'R') THEN FejlX := TRUE;
                 END;
    #215       : BEGIN       { ^ }
                   IF NOT ToTal THEN EXIT;
                   IF (Ty = 'I') AND (Ty2 = 'I')
                     THEN TypeSt[Tnr] := 'I' ELSE TypeSt[Tnr] := 'R'
                 END;
    #216..#218 : BEGIN    { Tidsfunktioner }
                   TypeSt[Tnr] := 'I';
                   IF Ty <> 'T' THEN EXIT;
                 END;
    #219..#221 : BEGIN    { Datofunktioner }
                   TypeSt[Tnr] := 'I';
                   IF Ty <> 'D' THEN EXIT;
                 END;
    #223       : BEGIN    { REP  Repeter }
                   IF Ty <> 'L' THEN EXIT;
                   Algoritme[Nr][Anr] := #251;  { Logisk OR }
                   INC(Anr);
                   Algoritme[Nr][Anr] := #223;  { gentag }
                   INC(Anr);
                   Algoritme[Nr][Anr] := Loop;  { fra }
                 END;
    #224..#241 : BEGIN    { Relle funktioner }
                   TypeSt[Tnr] := 'R';
                   IF (Ty <> 'I') AND (Ty <> 'R') THEN EXIT;
                 END;
    #243..#244 : BEGIN     { Talfunktioner }
                   IF (Ty <> 'I') AND (Ty <> 'R') THEN EXIT;
                 END;
    #245       : BEGIN     { INT }
                   TypeSt[Tnr] := 'I';
                   IF (Ty <> 'I') AND (Ty <> 'R') THEN EXIT;
                 END;
    #246       : IF (Ty = 'I') OR (Ty = 'R') THEN BEGIN
                     TypeSt[Tnr] := 'I';
                     IF Ty = 'R' THEN FejlX := TRUE;
                 END ELSE BEGIN
                   Algoritme[Nr][Anr] := CHR(2+ORD(Op));
                   IF Ty <> 'L' THEN EXIT;
                 END;
    #247       : BEGIN
                   IF (Ty <> 'I') AND (Ty <> 'R') THEN EXIT;
                 END;
  END;
  FejlNr := GamFejl;
  StakNed := FALSE;
END;
FUNCTION PutTal : BOOLEAN;
BEGIN
  INC(Anr);
  Algoritme[Nr][Anr] := #128; { Nu kommer en konstant }
  MOVE(Tal,Algoritme[Nr][Anr+1],6);
  Anr := Anr + 6;
  INC(Tnr); { Stakdybde }
  TypeSt[Tnr] := TalTyp;
  IF ForrKode = ')' THEN PutTal := TRUE ELSE PutTal := FALSE;
  FejlMedd := 'Operator mangler';
  WHILE (Knr > 0) AND (KodeSt[Knr] > #215) DO
    IF StakNed THEN PutTal := TRUE;
  ForrKode := ')';
END;
FUNCTION PutVar : BOOLEAN;
BEGIN
  INC(Anr);
  Algoritme[Nr][Anr] := Kode;
  INC(Tnr);
  IF TalTyp = 'C' THEN TalTyp := 'S';
  TypeSt[Tnr] := TalTyp;
  IF ForrKode = ')' THEN PutVar := TRUE ELSE PutVar := FALSE;
  FejlMedd := 'Operator mangler';
  WHILE (Knr > 0) AND (KodeSt[Knr] > #215) DO
    IF StakNed THEN PutVar := TRUE;
  ForrKode := ')';
END;
FUNCTION PutKode : BOOLEAN;
VAR
  Gamle,Niveau  : CHAR;
BEGIN
  PutKode := FALSE;
  Gamle := ForrKode;
  ForrKode := '*';
  IF Gamle <> ')' THEN BEGIN
    IF Kode = #208 THEN BEGIN { - }
      INC(Knr);
      KodeSt[Knr] := #247; { vend fortegn }
      EXIT;
    END;
    IF Kode = #209 THEN EXIT; { + }
  END;
  PutKode := TRUE;
  IF Kode = #255 THEN EXIT;
  FejlMedd := 'Tal savnes';
  IF Kode > #192 THEN
    IF Kode < #216 THEN
      IF Gamle <> ')' THEN EXIT;
  FejlMedd := 'Operator savnes';
  IF Kode > #215 THEN
    IF Gamle = ')' THEN EXIT;
  IF Kode < #216 THEN ForrKode := '*' ELSE ForrKode := '(';
  CASE Kode OF
    #193..#199 : Niveau := #192;
    #200..#207 : Niveau := #199;
    #208..#209 : Niveau := #207;
    #210..#214 : Niveau := #209;
    #215       : Niveau := #214;
    #216..#247 : Niveau := #255;
  ELSE EXIT;
  END;
  WHILE (Knr > 0) AND (KodeSt[Knr] > Niveau) DO
    IF StakNed THEN EXIT;
  PutKode := FALSE;
  IF Kode = #223 THEN BEGIN
    INC(Anr);
    Loop := CHR(Anr);
    Algoritme[Nr][Anr] := #133;
  END;
  INC(Knr);
  KodeSt[Knr] := Kode;
  FejlSt[Knr] := FejlNr;
END;
FUNCTION EtTal(Kar : CHAR) : BOOLEAN; { Er Kar et tal ? }
BEGIN
  IF POS(Kar,'.0123456789') > 0 THEN EtTal := TRUE ELSE EtTal := FALSE;
END;
FUNCTION Bogstav(Kar : CHAR) : BOOLEAN;
BEGIN
  IF (POS(Kar,'') > 0) OR ((Kar >= 'A') AND (Kar <= 'Z'))
  THEN Bogstav := TRUE ELSE Bogstav := FALSE;
END;
BEGIN  { Hovedprogram }
  Alg := AlgoText[Nr];
  A := 0;
  Fejl := TRUE;
  FejlX := FALSE;
  IndxHeri := FALSE;
  FejlMedd := #39+' mangler';
  WHILE POS(#39,Alg) > 0 DO BEGIN  { Udskift strengkonstanter }
    FejlNr := POS(#39,Alg);        { med " og lg konverteret }
    Alg[FejlNr] := #13;            { vrdi i stak StrSt }
    B := POS(#39,Alg);
    IF B = 0 THEN EXIT;
    INC(A);
    Streng := COPY(Alg,FejlNr+1,B-FejlNr-1);
    FOR B := POS(#39,Alg) DOWNTO FejlNr + 1 DO Alg[B] := #32;
    StrSt[A] := TalAfStreng(Streng);
  END;
  Streng := '()()';
  FOR A := 1 TO LENGTH(Alg) DO BEGIN { Lav store bogstaver og }
    Tegn := UPCASE(Alg[A]);          { ens parenteser }
    B := POS(Tegn,'[]{}');
    IF B > 0 THEN Tegn := Streng[B];
    Alg[A] := Tegn;
  END;
  Alg := Alg + #32;
  Knr := 0;
  Snr := 0;
  Tnr := 0;
  Anr := 0;
  ForrKode := '(';
  FejlNr := 1;
  REPEAT
    Tegn := Alg[FejlNr];
    IF Tegn = ')' THEN BEGIN
      REPEAT
        IF Knr = 0 THEN BEGIN
          FejlMedd := '( mangler';
          EXIT;
        END;
        Kode := KodeSt[Knr];
        IF StakNed THEN EXIT;
      UNTIL Kode = #192; { indtil parentes begyndt }
      DEC(Anr);
      ForrKode := ')';
      Tegn := #32;
    END;
    IF Tegn = '(' THEN BEGIN
      INC(Knr);
      KodeSt[Knr] := #192;
      ForrKode := '(';
      Tegn := #32;
    END;
    IF Tegn = #13 THEN BEGIN { Strengkonstant }
      TalTyp := 'S';
      INC(Snr);
      Tal := StrSt[Snr];
      IF PutTal THEN EXIT;
      Tegn := #32;
    END;
    FejlMedd := 'Illegalt tal';
    IF Tegn = '$' THEN BEGIN { Hexadecimalkonstant }
      TalTyp := 'I';
      A := FejlNr;
      Tal := 0;
      WHILE POS(Alg[A+1],'0123456789ABCDEF') > 0 DO INC(A);
      IF A = FejlNr THEN EXIT;
      FOR B := FejlNr + 1 TO A DO
        Tal := 16*Tal + POS(Alg[B],'0123456789ABCDEF') - 1;
      IF PutTal THEN EXIT;
      FejlNr := A;
      Tegn := #32;
    END;
    IF EtTal(Tegn) THEN BEGIN { Decimalkonstant }
      A := FejlNr;
      WHILE EtTal(Alg[1+A]) DO INC(A);
      IF Alg[1+A] = 'E' THEN BEGIN
        INC(A);
        IF Alg[1+A] = '-' THEN INC(A);
      END;
      WHILE EtTal(Alg[1+A]) DO INC(A);
      Streng := COPY(Alg,FejlNr,A-FejlNr+1);
      IF Tegn = '.' THEN INSERT('0',Streng,1);
      VAL(Streng,Tal,I);
      IF I <> 0 THEN EXIT;
      IF FRAC(Tal) = 0 THEN TalTyp := 'I' ELSE TalTyp := 'R';
      IF PutTal THEN EXIT;
      FejlNr := A;
      Tegn := #32;
    END;
    IF Tegn = '?' THEN BEGIN { Logikkonstant }
      TalTyp := 'L';
      Kode := #132;
      IF PutVar THEN EXIT;
      Tegn := #32;
    END;
    IF POS(Tegn,'<=>') > 0 THEN BEGIN { Sammenligninger }
      FejlMedd := 'Illegal relation';
      A := FejlNr;
      WHILE POS(Alg[1+A],'<=>') > 0 DO INC(A);
      Streng := COPY(Alg,FejlNr,A-FejlNr+1);
      Kode := #255;
      FOR B := 200 TO 207 DO
        IF Streng = Funktion[B-192] THEN Kode := CHR(B);
      IF PutKode THEN EXIT;
      FejlNr := A;
      Tegn := #32;
    END;
    IF POS(Tegn,'-+*////^') > 0 THEN BEGIN
      Kode := CHR(207+POS(Tegn,'-+*////^'));
      IF PutKode THEN EXIT;
      Tegn := #32;
    END;
    IF Bogstav(Tegn) THEN BEGIN { Funktioner, Operatorer og Variabler }
      A := FejlNr;
      WHILE Bogstav(Alg[1+A]) OR EtTal(Alg[1+A]) DO INC(A);
      Streng := COPY(Alg,FejlNr,A-FejlNr+1);
      Kode := #0;
      FOR B := 1 TO 63 DO
        IF Streng = Funktion[B] THEN Kode := CHR(B+192);
      IF Kode > #192 THEN BEGIN   { Er det en instruks ? }
        CASE Kode OF
            #248 : BEGIN
                     Kode := #129;
                     TalTyp := 'R';
                   END; { Put PI }
            #249 : BEGIN
                     Kode := #130;
                     TalTyp := 'L';
                   END; { Put SAND }
            #250 : BEGIN
                     Kode := #131;
                     TalTyp := 'L';
                   END; { Put FALSK }
        END;
        IF Kode < #132 THEN BEGIN
          IF PutVar THEN EXIT;
        END ELSE IF PutKode THEN EXIT;
      END ELSE BEGIN              { S m det vre en variabel }
        FejlMedd := 'Ikke defineret';
        Kode := CHR(FeltNr(Streng));
        IF Kode = #255 THEN EXIT;
        IF Kode = #127 THEN TalTyp := 'I'
          ELSE TalTyp := FeltType[63 AND ORD(Kode)];
        IF PutVar THEN EXIT;
        IF Kode > #63 THEN IndxHeri := TRUE;
      END;
      FejlNr := A;
      Tegn := #32;
    END;
    IF Tegn <> #32 THEN EXIT;
    INC(FejlNr);
  UNTIL FejlNr = LENGTH(Alg);
  WHILE Knr > 0 DO BEGIN
    IF StakNed THEN EXIT;
    FejlMedd := 'Mangler )';
    IF KodeSt[Knr+1] = #192 THEN EXIT;
  END;
  Algoritme[Nr][0] := CHR(Anr);
  AlgoType[Nr] := TypeSt[1];
  IndxIAlg[Nr] := IndxHeri;
  FejlMedd := 'Tomt udsagn';
  IF Anr > 0 THEN Fejl := FALSE
  ELSE FejlNr := 0;
END; { Slut p hovedprogram }

PROCEDURE VGAdrive; EXTERNAL;
{$L VGAD.OBJ}

PROCEDURE LaesVinG(VAR Strengen; X0,Xb,Y0,Yb : INTEGER;Posi : BYTE;Ring : BOOLEAN);
VAR
  C1 : CHAR;
  Ln : BYTE;
  L1,L2,L3 : INTEGER;
  Sw : STRING;
  PROCEDURE GenSkriv;
  VAR
    L4 : INTEGER;
  BEGIN
    FOR L4 := SUCC(Posi) TO LENGTH(Sw) DO BEGIN
      WRITE(Sw[L4]);
      IF (L4 MOD Xb) = 0 THEN GOTOXY(X0,Y0 + (L4 DIV Xb));
    END;
    IF LENGTH(Sw) < Xb*Yb THEN WRITE(#32);
  END;
  PROCEDURE NulSkriv;
  VAR
    L4 : INTEGER;
    Ax,Ay : CHAR;
  BEGIN
    Ax := Sw[0];
    IF LENGTH(Sw) < 255 THEN FILLCHAR(Sw[SUCC(ORD(Ax))],255-ORD(Ax),#32);
    Sw[0] := #255;
    FOR L4 := 0 TO PRED(Yb) DO BEGIN
      GOTOXY(X0,Y0+L4);
      WRITE(COPY(Sw,SUCC(Xb*L4),Xb));
    END;
    Sw[0] := Ax;
  END;
BEGIN
  IF Ring THEN BEGIN
    L1 := PRED(X0);
    L2 := PRED(Y0);
    REPEAT
      INC(L1);
      GOTOXY(L1,L2);
      WRITE('');
    UNTIL L1 = X0 + Xb;
    GOTOXY(L1,L2);
    WRITE('');

    REPEAT
      INC(L2);
      GOTOXY(L1,L2);
      WRITE('');
    UNTIL L2 = Y0 + Yb;
    GOTOXY(L1,L2);
    WRITE('');

    REPEAT
      DEC(L1);
      GOTOXY(L1,L2);
      WRITE('');
    UNTIL L1 = PRED(X0);
    GOTOXY(L1,L2);
    WRITE('');

    REPEAT
      DEC(L2);
      GOTOXY(L1,L2);
      WRITE('');
    UNTIL L2 = PRED(Y0);
    GOTOXY(L1,L2);
    WRITE('');
  END;
  Sw := STRING(Strengen);

  NulSkriv;

  REPEAT
    GOTOXY(X0 + (Posi MOD Xb),Y0 + (Posi DIV Xb));
    C1 := READKEY;
    IF (C1 = #0) OR (C1 = #8) OR (C1 = #127) THEN BEGIN
      IF C1 = #0 THEN C1 := READKEY;
      CASE ORD(C1) OF
        08 : IF Posi > 0 THEN BEGIN
               DELETE(Sw,Posi,1);
               DEC(Posi);
               GOTOXY(X0 + (Posi MOD Xb),Y0 + (Posi DIV Xb));
               GenSkriv;
             END;
        71 : Posi := 0;
        72 : IF Posi >= Xb THEN Posi := Posi - Xb;
        75 : IF Posi > 0 THEN DEC(Posi);
        77 : IF Posi < PRED(Xb*Yb) THEN INC(Posi);
        79 : Posi := LENGTH(Sw);
        80 : IF Posi + Xb < Xb*Yb THEN Posi := Posi + Xb;
        82 : BEGIN END; { SkiftInds }
        83 : IF LENGTH(Sw) > Posi THEN BEGIN
               DELETE(Sw,SUCC(Posi),1);
               GenSkriv;
             END;
       117 : IF LENGTH(Sw) > Posi THEN BEGIN  { ^End }
               Sw[0] := CHR(Posi);
               NulSkriv;
             END;
       119 : BEGIN  { ^Home }
               Sw := '';
               Posi := 0;
               NulSkriv;
             END;
       127 : BEGIN  { ^Rubout }
               DELETE(Sw,1,Posi);
               Posi := 0;
               NulSkriv;
             END;
      END;           {  write(ord(c1));  halt; }
      C1 := #0;
    END;
    IF C1 > #31 THEN BEGIN
      IF Posi > LENGTH(Sw) THEN FOR L1 := SUCC(LENGTH(Sw)) TO Posi DO Sw := Sw + #32;
      INSERT(C1,Sw,SUCC(Posi));
      GenSkriv;
      IF Posi < PRED(Xb*Yb) THEN INC(Posi);
    END;
    IF LENGTH(Sw) > Xb*Yb THEN Sw[0] := CHR(Xb*Yb);
    WHILE Sw[LENGTH(Sw)] = #32 DO DEC(Sw[0]);
  UNTIL (C1 = #13) OR (C1 = #27);
  IF C1 = #13 THEN STRING(Strengen) := Sw;
END;

PROCEDURE MakeGraph;
BEGIN
  Xven := (GETMAXX DIV 8);
  Xhoj := (GETMAXX - (Xven DIV 2));
  Yopp := (GETMAXY DIV 16);
  Yned := (GETMAXY - Yopp);
  LINE(Xven - 6,Yned,Xhoj,Yned);
  LINE(Xven,Yopp,Xven,Yned + 6);
END;

VAR
  RamTop : POINTER;

PROCEDURE GetRam;
VAR
  I : INTEGER;
BEGIN
  MARK(RamTop);
  FOR I := 0 TO 1023 DO NEW(DataPntr[I]);
END;

PROCEDURE FreRam;
BEGIN
  RELEASE(RamTop);
END;

PROCEDURE Nulfilter(VAR S : FeltStrg);
BEGIN
  WHILE 0 < POS('0E',S) DO DELETE(S,POS('0E',S),1);
  IF 0 < POS('.E',S) THEN DELETE(S,POS('.E',S),1);
END;

PROCEDURE TestOne;
VAR
  L1,L2,Y,X : INTEGER;
  Tl : LONGINT;
  V1,V2,Vl,Vh : REAL;
  Xmin,Xmax : REAL;
  Xbid,Ybid : BYTE;
  S : FeltStrg;
BEGIN
  MakeGraph; { her dannes Xhoj og Xven }
  DataAnt := Xhoj - Xven;
  Xbid := 10;
  Ybid := 10;
  Xmin := Xlimits[1][1];
  Xmax := Xlimits[1][2];
  FOR L1 := 2 TO AlgoAntl DO BEGIN
    IF Xmin > Xlimits[L1][1] THEN Xmin := Xlimits[L1][1];
    IF Xmax < Xlimits[L1][2] THEN Xmax := Xlimits[L1][2];
  END;
  V2 := Xmax;
  PaenGraense(Xmin,Xmax,Xbid);
  V1 := (Xmax-Xmin)/Xbid;
  WHILE Xmax/(V2 + V1) > 0.99 DO BEGIN
    Xmax := Xmax - V1;
    DEC(Xbid);
  END;
  FOR L1 := 0 TO DataAnt
    DO DataPntr[L1]^[1] := Xmin + L1*V1*Xbid/SUCC(DataAnt);
  PostNr := 0;
  Vl := BeregnAlgoritme(1);
  Vh := Vl;
  FOR L1 := 1 TO AlgoAntl DO BEGIN
    FOR PostNr := 0 TO DataAnt DO BEGIN
      IF (DataPntr[PostNr]^[1] >= Xlimits[L1][1])
       AND (DataPntr[PostNr]^[1] <= Xlimits[L1][2])
        THEN V1 := BeregnAlgoritme(L1)
        ELSE V1 := Udefineret;
        DataPntr[PostNr]^[SUCC(L1)] := V1;
        IF V1 <> Udefineret THEN BEGIN
          IF V1 > Vh THEN Vh := V1;
          IF V1 < Vl THEN Vl := V1;
        END;
    END;
  END;

  IF Vl = Vh THEN BEGIN
    Vh := Vh + 1;
    Vl := Vl - 1;
  END;

  V2 := Vh;
  PaenGraense(Vl,Vh,Ybid);
  V1 := (Vh-Vl)/Ybid;
  WHILE (V2 + V1) < Vh DO BEGIN
    Vh := Vh - V1;
    DEC(Ybid);
  END;

  FOR L1 := 0 TO PRED(Ybid) DO BEGIN
    Tl := Yned - Yopp;
    Tl := Yopp + (Tl*L1) DIV Ybid;
    LINE(Xven - 4,Tl,Xven,Tl);
  END;
  FOR L1 := 1 TO Xbid DO BEGIN
    Tl := Xhoj - Xven;
    Tl := Xven + (Tl*L1) DIV Xbid;
    LINE(Tl,Yned,Tl,Yned + 4);
  END;

  SETTEXTJUSTIFY(RIGHTTEXT,CENTERTEXT);
  S := FireCifr(Vh);
  Nulfilter(S);
  OUTTEXTXY(Xven - 8,Yopp,S);
  S := FireCifr(Vl);
  Nulfilter(S);
  OUTTEXTXY(Xven - 8,Yned,S);
  SETTEXTJUSTIFY(CENTERTEXT,TOPTEXT);
  S := FireCifr(Xmin);
  Nulfilter(S);
  OUTTEXTXY(Xven,Yned + 8,S);
  S := FireCifr(Xmax);
  Nulfilter(S);
  OUTTEXTXY(Xhoj,Yned + 8,S);

  FOR L1 := 2 TO SUCC(AlgoAntl) DO BEGIN
    SETCOLOR(1+L1);
    Xbid := 0;
    FOR L2 := 0 TO DataAnt DO BEGIN
      X := Xven + ROUND((Xhoj - Xven)*(DataPntr[L2]^[1] - Xmin)/(Xmax - Xmin));
      Y := Yned + ROUND((Yopp - Yned)*(DataPntr[L2]^[L1] - Vl)/(Vh - Vl));
      IF DataPntr[L2]^[L1] <> Udefineret THEN BEGIN
        IF Xbid = 0 THEN MOVETO(X,Y) ELSE LINETO(X,Y);
        Xbid := 1;
      END;
    END;
    SETTEXTJUSTIFY(LEFTTEXT,CENTERTEXT);
    IF (Xbid = 1) AND (AlgoAntl > 1) THEN OUTTEXT(' '+CHR(48+PRED(L1)));
  END;
END;

PROCEDURE Xrange;
VAR
  H,I,J : INTEGER;
  S : FeltStrg;
BEGIN
  IF (Xlimits[FeltAntl][1] = Xlimits[FeltAntl][2])
    THEN Xlimits[FeltAntl] := Xlimits[AlgoAntl];
  REPEAT
  FOR H := 1 TO 2 DO BEGIN
    GOTOXY(2,3 + H + 7*(AlgoAntl MOD 3));
    IF H = 1 THEN WRITE('Min') ELSE WRITE('Max');
    WRITE('. X:');
    S := FireCifr(Xlimits[FeltAntl][H]);
    REPEAT
      GOTOXY(10,3 + H + 7*(AlgoAntl MOD 3));
      J := Readln2(S,10);
      VAL(S,Xlimits[FeltAntl][H],I);
    UNTIL (J = 13) AND (I = 0);
  END;
  UNTIL Xlimits[FeltAntl][1] < Xlimits[FeltAntl][2];
END;

PROCEDURE Save_Formulas;
VAR
  F : TEXT;
  S : STRING;
  I : INTEGER;
BEGIN
  S := COPY(PlotFileName,1,PRED(BYTE(POS('.',PlotFileName))));
  S := S + '.FKT';
  ASSIGN(F,S);
  REWRITE(F);
  FOR I := 1 TO AlgoAntl DO WRITELN(F,CHR(48+I),':',AlgoText[I]);
  CLOSE(F);
END;

PROCEDURE Get_Formulas;
VAR
  F : TEXT;
  S : STRING;
BEGIN
  ASSIGN(F,'TESTCURV.FKT');
  {$I-}
  RESET(F);
  {$I+}
  IF IORESULT = 0 THEN BEGIN
    WHILE NOT EOF(F) DO BEGIN
      READLN(F,S);
      DELETE(S,1,POS(':',S));
      IF S <> '' THEN BEGIN
        INC(AlgoAntl);
        AlgoText[AlgoAntl] := S;
      END;
    END;
    CLOSE(F);
  END;
END;

PROCEDURE WriteInstructions;
BEGIN
  CLRSCR;
  WRITELN;
  WRITELN('                          Velkommen til Q_PLOT');
  WRITELN;
  WRITELN('   et program til grafisk fremstilling af matematiske funktioner og formler');
  WRITELN;
  WRITELN('   Dette program er skrevet i TurboPascal 4.0 til DOS milj, og virker fint');
  WRITELN('   i en DOS session under OS/2 (helskrm hvis DOS-VGA ikke er understttet)');
  WRITELN;
  WRITELN('   Danner grafikfil i HPGL formatet, som kan lses af mange tegneprogrammer');
  WRITELN('   og flere nyerere teksbehandlingsprogrammer, som f. eks. i IBM Works');
  WRITELN;
  WRITELN('   Bruges som flger:');
  WRITELN('   1 Indtast nskede funktion, f. eks:  X*SIN(X*SQRT(X)) <Enter> og derp');
  WRITELN('   2 Grnsevrdierne, d.v.s. minimum og maximum for X');
  WRITELN('   3 Gentag 1 og 2 ELLER tast <Enter> p det tomme vindue og');
  WRITELN('   4 Angiv navnet p filen til HPGL data (det er ASCII data)');
  WRITELN;
  WRITELN;
  WRITELN('   Skrevet i 1995 af         Lars Quist');
  WRITELN('                             Godthbsvej 102, 3. th');
  WRITELN('                             DK-2000 Frederiksberg');
  WRITELN;
  WRITELN(' Ideas and code in this material may be copied provided the author is credited');
  WRITELN;
  Get_Formulas;
  WRITELN('                             tryk p en tast');
  REPEAT UNTIL READKEY <> #0;
END;

BEGIN
  DataAnt := REGISTERBGIDRIVER(@VGAdrive);
  ZeroVars;
  GetRam;
  Driver := DETECT;
  Mode := 0;
  TEXTCOLOR(BROWN);
  TEXTBACKGROUND(LIGHTGRAY);
  WriteInstructions;
  INITGRAPH(Driver,Mode,'');
  PlotFileName := 'CURVES01.HGL';
  PlotOn := FALSE;
  DIRECTVIDEO := TRUE;
 REPEAT
  RESTORECRTMODE;
  TEXTCOLOR(BROWN);
  TEXTBACKGROUND(LIGHTGRAY);
  CLRSCR;
  GOTOXY(2,25);
  WRITE('Afslut formler ved <Enter> p tomt vindue    ^Home = Slet alt    ^Break = Slut');
  Fejl := FALSE;
  FejlNr := 0;
  AlgoAntl := 0;
  FeltAntl := 1;
  Bool1 := FALSE;
  GOTOXY(2,1);
  WRITE('Variable: ','X');
  REPEAT
    GOTOXY(2,3 + 7*(AlgoAntl MOD 3));
    WRITE('Formel for ',CHR(49+AlgoAntl),'. kurve:');
    GOTOXY(2,4 + 7*(AlgoAntl MOD 3));
    IF Fejl THEN WRITE(FejlMedd);
    Fejl := FALSE;
    IF FejlNr > 0 THEN DEC(FejlNr);
    LaesVinG(AlgoText[SUCC(AlgoAntl)],24,50,3 + 7*(AlgoAntl MOD 3),5,FejlNr,TRUE);
    GOTOXY(2,4 + 7*(AlgoAntl MOD 3));
    WRITE('                    ');
    IF AlgoText[SUCC(AlgoAntl)] <> '' THEN BEGIN
      FortolkAlgoritme(SUCC(AlgoAntl));
      IF NOT Fejl THEN BEGIN
        Xrange;
        INC(AlgoAntl);
        INC(FeltAntl);
        IF AlgoAntl < 6 THEN BEGIN
          GOTOXY(5+12*AlgoAntl,1);
          WRITE(FeltNavn[FeltAntl],' = f(',FeltNavn[AlgoAntl],')');
        END;
        FejlNr := 0;
      END;
    END ELSE Bool1 := TRUE;
  UNTIL (Bool1 OR (AlgoAntl = 6)) AND NOT Fejl;
  IF AlgoAntl = 0 THEN HALT;
  GOTOXY(2,24);
  WRITE('Gem i fil: (^End = skip) ');
  PlotOn := ((13 = ReadLn2(PlotFileName,48)) AND (PlotFileName[0] > #4));
  IF PlotOn THEN BEGIN
    Save_Formulas;
  END;
  SETGRAPHMODE(Mode);
  SETCOLOR(LIGHTRED);
  SETBKCOLOR(63);
  CLEARDEVICE;
  TestOne;
  IF PlotOn THEN PlotEnd;
 UNTIL UPCASE(READKEY) = 'S';
  FreRam;

END.